-- Version 9.0
-- Author: Ragefury-Skywall

--====================INTERFACE====================
local frame = CreateFrame("Frame")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

--====================VARIABLES====================
-- Items (15% Haste Buff)
local LUST_ITEMS_15 = {
	[146555] = true, 	-- Drums of Rage (Mists of Pandaria)
	[178207] = true, 	-- Drums of Fury (Warlords of Draenor)
	[230935] = true, 	-- Drums of the Mountain (Legion)
	[256740] = true, 	-- Drums of the Maelstrom (Battle For Azeroth)
	[292686] = true,	-- Mallet of Thunderous Skins (Battle For Azeroth)
	[309658] = true,    -- Drums of Deathly Ferocity (Shadowlands)
}
-- Lust Spells (30% Haste Buff)
local LUST_SPELLS_30 = {
	[2825] = true, 		-- Bloodlust (Horde Shaman)
	[32182] = true, 	-- Heroism (Alliance Shaman)
	[80353] = true, 	-- Time Warp (Mage)
	[272678] = true, 	-- Primal Rage (Hunter Ferocity Ability)
}

-- Debuff Spells
local LUST_DEBUFFS = {
	"Exhaustion",
	"Sated",
	"Temporal Displacement",
	"Insanity",
	"Fatigued",
}

--====================FUNCTIONS====================
frame:SetScript("OnEvent", function(self, event, ...)
	-- Script on Combat Log Event
	local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, _ = CombatLogGetCurrentEventInfo()
		if event == "SPELL_CAST_SUCCESS" and GetNumGroupMembers() > 0 and (LUST_ITEMS_15[spellID] or LUST_SPELLS_30[spellID]) and (UnitInParty(sourceName) or UnitPlayerOrPetInParty(sourceName) or UnitPlayerOrPetInRaid(sourceName) or UnitInBattleground(sourceName)) then
			-- Get Chat Type
			local chatType = "PARTY"
			local isInstance, instanceType = IsInInstance()
			if isInstance and IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or instanceType == "pvp" then
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid() then
				chatType = "RAID"
			end

			-- Broadcast Group
			if LUST_ITEMS_15[spellID] then -- 15% Haste Buffs
				SendChatMessage("LustPopper: " .. UnitName(sourceName) .. " used " .. GetSpellLink(spellID) .. " (15% Haste)", chatType)
			elseif LUST_SPELLS_30[spellID] then -- 30% Haste Buffs
				SendChatMessage("LustPopper: " .. UnitName(sourceName) .. " cast " .. GetSpellLink(spellID) .. " (30% Haste)", chatType)
			end
		end
	end
)